Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.beans
Class Document

    java.lang.Object
      oracle.ifs.beans.LibraryObject
          oracle.ifs.beans.TieLibraryObject
              oracle.ifs.beans.PublicObject
                  oracle.ifs.beans.TiePublicObject
                      oracle.ifs.beans.Document

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, PublicObjectInterface, Traceable

Direct Known Subclasses:
  RecipeDocument, T1kDocument, TieDocument

    public class Document

extends TiePublicObject

The Document class is a subclass of PublicObject that supports getting and setting Content. Content is any unstructured data. This is facilitated by referring to a ContentObject. ContentObjects allow getting and setting of content, as well as supporting content meta data. This class contains convenience covers to make using a ContentObject easier. Document content is set using a ContentObject Definition, although it can also be set using a DocumentDefinition. A DocumentDefinition supports setting content from a variety of sources, including a local file and an InputStream. You use a DocumentDefinition both for creating a new document and updating an existing one.

See Also:
  `ContentObject`, `DocumentDefinition`
(Published)

Field Summary
`static java.lang.String` | `CLASS_NAME` This class name for this class.
`static java.lang.String` | `CONTENTOBJECT_ATTRIBUTE` The ContentObject that contains this document's content.
`static java.lang.String` | `CONTENTQUOTA_ATTRIBUTE` The ContentQuota being charged for this document's content.
`static java.lang.String` | `INITIALLIFECYCLEDATE_ATTRIBUTE` The initial base date used to manage lifecycle of this document.
`static java.lang.String` | `LIFECYCLEDATE_ATTRIBUTE` The current base date used to manage lifecycle of this document.
`static java.lang.String` | `LIFECYCLEPOLICY_ATTRIBUTE` The LifecyclePolicy which describes the lifecycle rules for this document.
`static java.lang.String` | `LIFECYCLEPOLICYENTRYID_ATTRIBUTE` The ID of the LifecyclePolicyEntry that represents the current lifecycle state of the Document, or null if no LifecyclePolicy is set.
`static java.lang.String` | `LIFECYCLEPOLICYID_ATTRIBUTE` Attribute which holds the ID of the LifecyclePolicy if set or null if not set; used for indexing purposes.
`static java.lang.String` | `READBYOWNER_ATTRIBUTE` An indicator of whether the Document Owner has read the current content.
`static java.lang.String` | `RETENTIONPOLICY_ATTRIBUTE` The RetentionPolicy which describes the retention rules for this document.

Fields inherited from class oracle.ifs.beans.PublicObject
`ACL_ATTRIBUTE, CREATEDATE_ATTRIBUTE, CREATOR_ATTRIBUTE, DELETOR_ATTRIBUTE, DESCRIPTION_ATTRIBUTE, EXPIRATIONDATE_ATTRIBUTE, FAMILY_ATTRIBUTE, FLAG_CATEGORY_EXISTS, FLAG_CONFIGURATIONCATEGORY_EXISTS, FLAG_MARKED, FLAG_NOINFERIOR, FLAG_NOSELECT, FLAG_NTFS_ARCHIVE, FLAG_NTFS_HIDDEN, FLAG_NTFS_READONLY, FLAG_NTFS_SYSTEM, FLAG_UNMARKED, FLAGS_ATTRIBUTE, LASTMODIFIER_ATTRIBUTE, LASTMODIFYDATE_ATTRIBUTE, LOCKENTRIES_ATTRIBUTE, LOCKOBJECT_ATTRIBUTE, NAME_ATTRIBUTE, OWNER_ATTRIBUTE, POLICYBUNDLE_ATTRIBUTE, POLICYLISTS_ATTRIBUTE, PRIMARYPARENTFOLDER_ATTRIBUTE, PROPERTYBUNDLE_ATTRIBUTE, RESOLVEDPUBLICOBJECT_ATTRIBUTE, SECURINGPUBLICOBJECT_ATTRIBUTE`

Fields inherited from class oracle.ifs.beans.LibraryObject
`DOMAIN_UNIQUENAME_DEFAULT_DELIMITER, m_ClassId, m_Id, m_Session`

Constructor Summary
`protected` | `Document(LibrarySession session, java.lang.Long id, java.lang.Long classId, S_LibraryObjectData data)` Constructs a Document object - standard variant.

Method Summary
`protected void` | `auditContentRead(int mode)` Audits content being read.
`protected void` | `auditLifecyclePolicyCleared(LifecyclePolicy lp)` Audit the clearing of a LifecyclePolicy from this document.
`protected void` | `auditLifecyclePolicySet(LifecyclePolicy lp)` Audit the setting of a LifecyclePolicy on this document.
`void` | `auditLifecycleStateUpdated(LifecyclePolicyEntry lpe)` Audit the update of Lifecycle state on this document.
`protected void` | `auditPublicObjectLocked(int lockType)` Audits a PublicObject being locked.
`protected void` | `auditPublicObjectUnlocked(int lockType)` Audits a PublicObject being unlocked.
`protected void` | `auditRetentionPolicyCleared(RetentionPolicy rp)` Audit the clearing of a RetentionPolicy from this document.
`protected void` | `auditRetentionPolicySet(RetentionPolicy rp)` Audit the setting of a RetentionPolicy on this document.
`protected void` | `auditUpdated(LibraryObjectDefinition lodef)` Creates audit events for the update operation.
`PublicObjectCapabilities` | `capabilities()` Returns the PublicObjectCapabilities delegate which tracks the capabilities of this object.
`protected static Document` | `constructDocument(LibrarySession sess, S_LibraryObjectData data)` Constructs a Document object from the S_LibraryObjectData object.
`protected static java.util.Vector` | `constructDocumentVector(LibrarySession sess, java.util.Vector vector)` Returns Document Vector from a Vector of S_DocumentData objects.
`void` | `filterContent(boolean plaintext)` Generates a HTML or plaintext version of the document, via the Context INSO filters.
`java.lang.String` | `generateFilename()` Generates a filename which is the objectname plus the format extension.
`void` | `generateSummary(java.lang.String pointOfView, long sizeAsPercent, long sizeAsNumParagraphs, java.lang.String summaryLevel)` Generates one or more summaries for a document by submitting a request to Context to generate summaries.
`void` | `generateThemes(boolean fullThemes)` Generates the Themes for this Document by submitting a request to Context to generate Themes.
`java.lang.String` | `getCharacterSet()` Returns the Iana character encoding of the content, or null if not specified.
`static java.lang.Long` | `getClassId(LibrarySession session)` Get the ID of the ClassObject representing DOCUMENT.
`RandomAccessor` | `getContentByRandomAccess()` Gets a RandomAccessor for randomly reading the content of this document.
`java.util.Date` | `getContentModificationDate()` Returns the date on which the CONTENT on this document was last modified.
`ContentObject` | `getContentObject()` Gets the content for this Document.
`ContentQuota` | `getContentQuota()` Gets the ContentQuota object being charged by this Document.
`java.io.Reader` | `getContentReader()` Gets the document content as a Reader
`long` | `getContentRowId()` Gets Content row ID.
`long` | `getContentSize()` Gets the size of this document's content.
`java.io.InputStream` | `getContentStream()` Gets the document content as an InputStream.
`LifecyclePolicyEntry` | `getCurrentLifecyclePolicyEntry()` Returns the current LifecyclePolicyEntry reflecting the current state of the document.
`java.io.Reader` | `getFilteredContent()` Gets the plaintext or HTML content of the document, previously generated by a call to filterContent()
`Format` | `getFormat()` Gets the format for this Document.
`java.util.Date` | `getInitialLifecycleDate()` Returns the initial base date used to manage lifecycle of this document.
`java.lang.String` | `getLanguage()` Gets the Oracle language of the content, or null if not specified.
`java.util.Date` | `getLifecycleDate()` Returns the current base date used to manage lifecycle of this document.
`LifecyclePolicy` | `getLifecyclePolicy()` Returns the LifecyclePolicy which describes the lifecycle rules for this document.
`int` | `getLifecycleState()` Returns the lifecycle state of the Document, derived from the current LifecyclePolicyEntryId setting.
`Media` | `getMedia()` Gets the media for this Document.
`java.lang.String` | `getMimeType()` Returns the MIME type of this Document's Format.
`LifecyclePolicyEntry` | `getNextLifecyclePolicyEntry()` Returns the next LifecyclePolicyEntry reflecting the state of the document once the next Lifecycle state is processed.
`RandomAccessContentInterface` | `getRandomAccessContent(boolean canWrite)` Deprecated. CM SDK 10gR2: use getContentByRandomAccess or updateContentByRandomAccess
`RandomAccessContentInterface` | `getRandomAccessContent(boolean canWrite, boolean shouldLock)` Deprecated. CM SDK 10gR2: use getContentByRandomAccess or updateContentByRandomAccess
`RetentionPolicy` | `getRetentionPolicy()` Returns the RetentionPolicy which describes the retention rules for this document.
`java.io.Reader` | `getSummary(java.lang.String pointOfView)` Gets a specific summary of a document, previously generated by a call to generateSummary().
`ContextTheme[]` | `getThemes()` Gets the Themes for a document, previously generated by a call to generateThemes().
`boolean` | `isBinaryFormat()` Returns indication as to whether the Document's Format is a binary format.
`boolean` | `isReadByOwner()` Returns true if the owner of the document has read the content via this document.
`boolean` | `isReadByUser()` Returns true if the current user has read the content to which this document refers.
`protected boolean` | `isValidEventType(AuditEvent event)` Checks to see if the event type in the process of being posted on the target LibraryObject is consistent with the target.
`protected void` | `postCreate(LibraryObjectDefinition lodef)` Extensibility point to perform actions after the creation of a PublicObject.
`protected void` | `preCreate(LibraryObjectDefinition lodef)` Extensibility point to perform actions prior to the creation of a PublicObject.
`protected void` | `preFree(LibraryObjectDefinition lodef)` Extensibility point to perform actions prior to the permanent deletion ("free") of a object.
`protected void` | `preUpdate(LibraryObjectDefinition lodef)` Extensibility point to perform actions prior to the update of a PublicObject.
`protected void` | `reportDocumentCreated()` Audits a Document create operation.
`protected void` | `reportDocumentFreed()` Audits a Document free operation.
`void` | `setCharacterSet(java.lang.String charset)` Sets the Iana character set for the document content.
`void` | `setContent(DocumentDefinition def)` Sets the content of this Document.
`void` | `setContentQuota(ContentQuota quota)` Sets the ContentQuota that will be charged by this Document.
`void` | `setFormat(Format format)` Sets the format for this Document.
`void` | `setLanguage(java.lang.String language)` Sets the language of the document content.
`void` | `setLifecycleDate(java.util.Date ldate)` Sets the base date used to manage lifecycle of this document.
`void` | `setLifecyclePolicy(LifecyclePolicy lp)` Sets the LifecyclePolicy which describes the lifecycle rules for this document.
`void` | `setReadByUser(boolean readState)` Sets read indication (for the current user) for the content referred to by this Document.
`void` | `setRetentionPolicy(RetentionPolicy rp)` Sets the RetentionPolicy which describes the retention rules for this document.
`RandomAccessor` | `updateContentByRandomAccess(DocumentDefinition docdef, java.lang.Long expirationPeriod)` Gets a RandomAccessor for randomly writing and reading the content of this document.
`protected static Document` | `vectorDocumentElement(java.util.Vector vector, int index)` Returns a Document element from the Vector of Document objects at the specified index.
`protected static Document[]` | `vectorToDocumentArray(java.util.Vector vector)` Converts a Vector of Document to an array of DirectoryGroup.
`protected ContentObject` | `verifyContentObject()` Verifies the ContentObject of this Document is set.

Methods inherited from class oracle.ifs.beans.PublicObject
`addAccess, addCategory, addFlags, addRelationship, canAcquireManualLock, canReleaseDavLock, canReleaseLock, canReleaseManualLock, checkAuditViewCapability, checkCapabilities, checkCapability, checkEffectiveAccess, checkEffectiveAccess, checkLockAccess, checkVersioned, clearFlags, constructPublicObject, constructPublicObjectArray, constructPublicObjectVector, copy, coreAutoFolderingEnabled, createCategories, createDedicatedPolicyPropertyBundle, delete, deriveEffectiveAccessLevel, free, getAcl, getAllFolderPaths, getAllFolderPaths, getAllFolderPaths, getAnyFolderPath, getAnyFolderPath, getAnyFolderPath, getCapabilities, getCategories, getCategories, getCategories, getCategories, getCategories, getCategory, getConsumedStorage, getCreateDate, getCreator, getDefaultAccessLevel, getDeletor, getDescription, getEffectiveAccessLevel, getEffectiveAccessLevel, getExpirationDate, getFamily, getFirstVersion, getFlags, getFolderReferences, getFolderReferences, getFolderReferencesSortSpecification, getLastModifier, getLastModifyDate, getLastVersion, getLeftwardRelationshipObjects, getLeftwardRelationshipObjects, getLeftwardRelationships, getLeftwardRelationships, getLeftwardRelationshipsCount, getLeftwardRelationshipsCount, getLinks, getLockEntries, getLockEntries, getLockObject, getLockRestrictions, getLockTypeAuditProperties, getNextVersion, getOwner, getPolicyBundle, getPolicyLists, getPreviousVersion, getPrimaryFolderPath, getPrimaryParentFolder, getPrimaryParentFolder, getReservationComment, getReservationDate, getReservor, getResolvedPublicObject, getRestrictingLockEntries, getRightwardRelationshipObjects, getRightwardRelationshipObjects, getRightwardRelationships, getRightwardRelationships, getSecuringPublicObject, getSingletonVersionDescription, getVersionNumber, getVersions, getVersionSeries, getWorkingCopy, grantAccess, handleCopy, handleCreate, handleUnlockAll, hasCategories, hasConfigurationCategories, hasNameAttribute, isDeleted, isLatestVersion, isLocked, isLockingSupported, isOwner, isReserved, isReservedByCurrentUser, isVersionable, isVersioned, isWorkingCopy, listLeftwardRelationships, listRightwardRelationships, lock, lock, lock, lock, newVersion, postCopy, postUpdate, preCopy, putPolicy, reassociateLinks, removeAllPolicies, removePolicy, removePolicy, removeRelationship, reserveNext, resetFolderReferences, resolveFolderReferenceSortSpecification, revokeAccess, revokeAllAccess, setAcl, setDescription, setExpirationDate, setFlags, setFolderReferencesSortSpecification, setLockEntries, setLockEntrySecurity, setOwner, setOwnerByName, setPolicyBundle, setPolicyLists, setSecuringPublicObject, toPublicObjectArray, undelete, unlock, unlock, unlockAll, unReserve, updateFlags, updateLock, vectorPublicObjectElement, vectorToPublicObjectArray, verifyDeleteCapability, verifyLockCapability, verifyUnlockCapability, verifyVersionSeries`

Methods inherited from class oracle.ifs.beans.LibraryObject
`applyProperties, auditCreated, checkRequiredAttributeSet, clearCopyContext, clearFreeContext, clearUpdateContext, constructIdArray, constructIdArray, constructLibraryObject, constructLibraryObjectVector, createDedicatedPropertyBundle, deriveDomainUniqueName, dispose, equals, free, get, getAttribute, getAttributeByUpperCaseName, getAttributes, getAttributesByUpperCaseNames, getAuditDomainContext, getAuditEventFolderContext, getClassId, getClassname, getClassName, getClassObject, getCommonName, getCopyContext, getCreateContext, getData, getDefinition, getEffectivePolicyListElements, getEventualAttributeByUpperCaseName, getFreeContext, getId, getLabel, getName, getObjectReferenceAttribute, getOperationActionSpecificationContext, getPropertyBundle, getPropertyValue, getPublicObjectAttribute, getResourceString, getResourceString, getSchemaObjectAttribute, getSession, getSessionInterface, getSharedStateFactory, getStringIdentifier, getSystemObjectAttribute, getTraceLogger, getUpdateContext, handleAdminModeChange, handleEvent, handleFree, handleUpdate, hashCode, invokeOperation, invokeOperation, invokeServerMethod, isConnected, isCoreEventPostingEnabled, isInstanceOf, isTraced, lockRows, lookupInstanceLabel, postEvent, postEvent, postFree, prePostAuditEvent, putProperty, putProperty, removeAllProperties, removeProperty, renderAsRandomAccessContent, renderAsReader, renderAsStream, setAttribute, setAttribute, setAttributes, setAttributes, setCopyContext, setFreeContext, setId, setName, setPropertyBundle, setPropertyValue, setUpdateContext, toString, trace, trustHandleCreate, trustHandleCreateAsAdmin, trustHandleFree, trustHandleFreeAsAdmin, trustHandleUpdate, trustHandleUpdateAsAdmin, update, updateAndExposeDefinition, validatePropertyValues, vectorLibraryObjectElement, vectorToLibraryObjectArray, verifyAdministrationMode, verifyConnected, verifySystemUserAccess, verifyTargetObject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.ifs.common.LibraryObjectInterface
`getAttributeByUpperCaseName, getClassId, getId, getSessionInterface`

Methods inherited from interface oracle.ifs.common.Traceable
`getTraceLogger, isTraced, trace`

Field Detail

### CLASS_NAME

    public static final java.lang.String CLASS_NAME

  Description copied from class: `Document`
  This class name for this class. Useful for methods that take a class name argument.

  See Also:
    Constant Field Values
  (Published)

### CONTENTOBJECT_ATTRIBUTE

    public static final java.lang.String CONTENTOBJECT_ATTRIBUTE

  Description copied from class: `Document`
  The ContentObject that contains this document's content.

  See Also:
    Constant Field Values
  (Published)

### READBYOWNER_ATTRIBUTE

    public static final java.lang.String READBYOWNER_ATTRIBUTE

  Description copied from class: `Document`
  An indicator of whether the Document Owner has read the current content.

  See Also:
    Constant Field Values
  (Published)

### CONTENTQUOTA_ATTRIBUTE

    public static final java.lang.String CONTENTQUOTA_ATTRIBUTE

  Description copied from class: `Document`
  The ContentQuota being charged for this document's content.

  See Also:
    Constant Field Values
  (Published)

### RETENTIONPOLICY_ATTRIBUTE

    public static final java.lang.String RETENTIONPOLICY_ATTRIBUTE

  Description copied from class: `Document`
  The RetentionPolicy which describes the retention rules for this document.

  See Also:
    Constant Field Values
  (Published)

### LIFECYCLEPOLICY_ATTRIBUTE

    public static final java.lang.String LIFECYCLEPOLICY_ATTRIBUTE

  Description copied from class: `Document`
  The LifecyclePolicy which describes the lifecycle rules for this document.

  See Also:
    Constant Field Values
  (Published)

### LIFECYCLEPOLICYID_ATTRIBUTE

    public static final java.lang.String LIFECYCLEPOLICYID_ATTRIBUTE

  Description copied from class: `Document`
  Attribute which holds the ID of the LifecyclePolicy if set or null if not set; used for indexing purposes.

  See Also:
    Constant Field Values
  (Published)

### LIFECYCLEPOLICYENTRYID_ATTRIBUTE

    public static final java.lang.String LIFECYCLEPOLICYENTRYID_ATTRIBUTE

  Description copied from class: `Document`
  The ID of the LifecyclePolicyEntry that represents the current lifecycle state of the Document, or null if no LifecyclePolicy is set.

  See Also:
    Constant Field Values
  (Published)

### INITIALLIFECYCLEDATE_ATTRIBUTE

    public static final java.lang.String INITIALLIFECYCLEDATE_ATTRIBUTE

  Description copied from class: `Document`
  The initial base date used to manage lifecycle of this document.

  See Also:
    Constant Field Values
  (Published)

### LIFECYCLEDATE_ATTRIBUTE

    public static final java.lang.String LIFECYCLEDATE_ATTRIBUTE

  Description copied from class: `Document`
  The current base date used to manage lifecycle of this document.

  See Also:
    Constant Field Values
  (Published)

Constructor Detail

### Document

    protected Document(LibrarySession session,
                       java.lang.Long id,
                       java.lang.Long classId,
                       S_LibraryObjectData data)
                throws IfsException

  Constructs a Document object - standard variant.

  Parameters:
    `session` - the session
    `id` - the id
    `classId` - the class id
    `data` - the Document data
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

Method Detail

### getClassId

    public static java.lang.Long getClassId(LibrarySession session)
                                     throws IfsException

  Description copied from class: `Document`
  Get the ID of the ClassObject representing DOCUMENT.

  Parameters:
    `session` - the session context
  Returns:
    the ID of the DOCUMENT ClassObject
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### capabilities

    public PublicObjectCapabilities capabilities()

  Description copied from class: `Document`
  Returns the PublicObjectCapabilities delegate which tracks the capabilities of this object.

  Overrides:
    `capabilities` in class `PublicObject`
  Returns:
    an instance of TieDocumentCapabilities

### getContentObject

    public ContentObject getContentObject()
                                   throws IfsException

  Description copied from class: `Document`
  Gets the content for this Document.

  Returns:
    the ContentObject
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getContentQuota

    public ContentQuota getContentQuota()
                                 throws IfsException

  Description copied from class: `Document`
  Gets the ContentQuota object being charged by this Document. Returns null if this document is not counted against any quota.

  Returns:
    the ContentQuota assigned to this group
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getRetentionPolicy

    public RetentionPolicy getRetentionPolicy()
                                       throws IfsException

  Description copied from class: `Document`
  Returns the RetentionPolicy which describes the retention rules for this document.

  Returns:
    the RetentionPolicy with which this object is associated
  Throws:
    `IfsException` -
    19003: if the object referenced is the wrong class
    other: if the operation fails

### getLifecyclePolicy

    public LifecyclePolicy getLifecyclePolicy()
                                       throws IfsException

  Description copied from class: `Document`
  Returns the LifecyclePolicy which describes the lifecycle rules for this document.

  Returns:
    the LifecyclePolicy with which this object is associated
  Throws:
    `IfsException` -
    19003: if the object referenced is the wrong class
    other: if the operation fails

### getCurrentLifecyclePolicyEntry

    public LifecyclePolicyEntry getCurrentLifecyclePolicyEntry()
                                                        throws IfsException

  Description copied from class: `Document`
  Returns the current LifecyclePolicyEntry reflecting the current state of the document.

  If no LifecyclePolicy is in effect, this method returns null. If the the document is still an the initial lifecycle state (pending processing of the first LifecyclePolicyEntry), this method also returns 0. If the caller needs to disambiguate, it has to call `getLifecyclePolicy` also.

  Returns:
    the current LifecyclePolicyEntry with which this object is associated
  Throws:
    `IfsException` -
    19003: if the object referenced is the wrong class
    other: if the operation fails

### getNextLifecyclePolicyEntry

    public LifecyclePolicyEntry getNextLifecyclePolicyEntry()
                                                     throws IfsException

  Description copied from class: `Document`
  Returns the next LifecyclePolicyEntry reflecting the state of the document once the next Lifecycle state is processed.

  If no LifecyclePolicy is in effect, this method returns null. If the the document has already proceeded to the last state, this method also returns 0. If the caller needs to disambiguate, it has to call `getLifecyclePolicy` also.

  Returns:
    the LifecyclePolicyEntry reflecting the next state to be processed
  Throws:
    `IfsException` -
    19003: if the object referenced is the wrong class
    other: if the operation fails

### getInitialLifecycleDate

    public java.util.Date getInitialLifecycleDate()
                                           throws IfsException

  Description copied from class: `Document`
  Returns the initial base date used to manage lifecycle of this document.

  Returns:
    the initial base lifecycle date
  Throws:
    `IfsException` - if the operation fails

### getLifecycleDate

    public java.util.Date getLifecycleDate()
                                    throws IfsException

  Description copied from class: `Document`
  Returns the current base date used to manage lifecycle of this document.

  Returns:
    the current base lifecycle date
  Throws:
    `IfsException` - if the operation fails

### getLifecycleState

    public int getLifecycleState()
                          throws IfsException

  Description copied from class: `Document`
  Returns the lifecycle state of the Document, derived from the current LifecyclePolicyEntryId setting.

  Returns the value of LifecyclePolicyEntry.LifecycleSequence for the current LifecyclePolicyEntryId. Returns zero if no LifecyclePolicy defined, or if the initial Lifecycle state is pending. The caller needs to disambiguate by using `getLifecyclePolicy`.

  Returns:
    the lifecycle state
  Throws:
    `IfsException` - if the operation fails

### setContentQuota

    public void setContentQuota(ContentQuota quota)
                         throws IfsException

  Description copied from class: `Document`
  Sets the ContentQuota that will be charged by this Document.

  Parameters:
    `quota` - the ContentQuota
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setRetentionPolicy

    public void setRetentionPolicy(RetentionPolicy rp)
                            throws IfsException

  Description copied from class: `Document`
  Sets the RetentionPolicy which describes the retention rules for this document.

  Parameters:
    `rp` - the RetentionPolicy
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setLifecyclePolicy

    public void setLifecyclePolicy(LifecyclePolicy lp)
                            throws IfsException

  Description copied from class: `Document`
  Sets the LifecyclePolicy which describes the lifecycle rules for this document.

  Parameters:
    `lp` - the LifecyclePolicy
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setLifecycleDate

    public void setLifecycleDate(java.util.Date ldate)
                          throws IfsException

  Description copied from class: `Document`
  Sets the base date used to manage lifecycle of this document.

  Parameters:
    `ldate` - the base date
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setFormat

    public void setFormat(Format format)
                   throws IfsException

  Description copied from class: `Document`
  Sets the format for this Document.

  Parameters:
    `format` - the desired Format object
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getMedia

    public Media getMedia()
                   throws IfsException

  Description copied from class: `Document`
  Gets the media for this Document.

  Returns:
    the Media object.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getFormat

    public Format getFormat()
                     throws IfsException

  Description copied from class: `Document`
  Gets the format for this Document.

  Returns:
    the Format object
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getMimeType

    public java.lang.String getMimeType()
                                 throws IfsException

  Description copied from class: `Document`
  Returns the MIME type of this Document's Format.

  Returns:
    the MIME type of this Document
  Throws:
    `IfsException` - on failure
  (Published)

### isBinaryFormat

    public boolean isBinaryFormat()
                           throws IfsException

  Description copied from class: `Document`
  Returns indication as to whether the Document's Format is a binary format.

  Returns:
    true if the Document's Format is a binary format
  Throws:
    `IfsException` - on failure
  (Published)

### getCharacterSet

    public java.lang.String getCharacterSet()
                                     throws IfsException

  Description copied from class: `Document`
  Returns the Iana character encoding of the content, or null if not specified.

  Returns:
    the Iana character set name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setCharacterSet

    public void setCharacterSet(java.lang.String charset)
                         throws IfsException

  Description copied from class: `Document`
  Sets the Iana character set for the document content. Be sure to use the Iana name (i.e. ISO-8859-1) The character set of a document is used in several ways. When the document content is rendered to a file, the character set of the document is used as the character encoding of the file. If the document is displayed in a browser, the character set of the document should be set in the HTTP content-type header. Also, when a full text search is built on a text document, Oracle Text uses the character set of the document to convert the data into the database character set before building the index.

  Parameters:
    `charset` - Iana name for the new character set
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getLanguage

    public java.lang.String getLanguage()
                                 throws IfsException

  Description copied from class: `Document`
  Gets the Oracle language of the content, or null if not specified.

  Returns:
    the Oracle language
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setLanguage

    public void setLanguage(java.lang.String language)
                     throws IfsException

  Description copied from class: `Document`
  Sets the language of the document content. The language is used for building a full text search index on the document with Oracle Text. Oracle Text's multilexer feature uses the language to identify the specific lexer to parse the document for searchable words.

  Parameters:
    `language` - language using Oracle naming convention.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getContentSize

    public long getContentSize()
                        throws IfsException

  Description copied from class: `Document`
  Gets the size of this document's content. It returns 0 (zero) if the content is zero length or if this document has a null ContentObject

  Returns:
    the size of the underlying content.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getContentRowId

    public long getContentRowId()
                         throws IfsException

  Description copied from class: `Document`
  Gets Content row ID.

  Returns:
    the ID of the underlying content row.
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### getContentModificationDate

    public java.util.Date getContentModificationDate()
                                              throws IfsException

  Description copied from class: `Document`
  Returns the date on which the CONTENT on this document was last modified. This is null if the document has no content

  Returns:
    the date when content was last modified
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getContentStream

    public java.io.InputStream getContentStream()
                                         throws IfsException

  Description copied from class: `Document`
  Gets the document content as an InputStream.

  Returns:
    an InputStream of the content or null if this document does not have content
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getContentReader

    public java.io.Reader getContentReader()
                                    throws IfsException

  Description copied from class: `Document`
  Gets the document content as a Reader

  Returns:
    a Reader of the content or null if this document does not have content
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getContentByRandomAccess

    public RandomAccessor getContentByRandomAccess()
                                            throws IfsException

  Description copied from class: `Document`
  Gets a RandomAccessor for randomly reading the content of this document.

  Returns:
    a RandomAccessor, or null if this document does not have content
  Throws:
    `IfsException` - if the operation fails
  (Published)

### updateContentByRandomAccess

    public RandomAccessor updateContentByRandomAccess(DocumentDefinition docdef,
                                                      java.lang.Long expirationPeriod)
                                               throws IfsException

  Description copied from class: `Document`
  Gets a RandomAccessor for randomly writing and reading the content of this document.

  After calling this method, `docdef` must not be further modified.

  Refer to `RandomAccessor` for further details.

  Parameters:
    `docdef` - a document definition
    `expirationPeriod` - the expiration period for the RandomAccessor, in seconds, or null for the default expiration period
  Returns:
    a RandomAccessor, or null if this document does not have content
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getRandomAccessContent

    public RandomAccessContentInterface getRandomAccessContent(boolean canWrite)
                                                        throws IfsException

  Deprecated. CM SDK 10gR2: use getContentByRandomAccess or updateContentByRandomAccess

  Description copied from class: `Document`
  Gets a RandomAccessContent object that can be used to read/write content "asynchronously".

  Parameters:
    `canWrite` - whether its a request for a writeable RACI
  Returns:
    a RandomAccessContentObject to access the document contents
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getRandomAccessContent

    public RandomAccessContentInterface getRandomAccessContent(boolean canWrite,
                                                               boolean shouldLock)
                                                        throws IfsException

  Deprecated. CM SDK 10gR2: use getContentByRandomAccess or updateContentByRandomAccess

  Description copied from class: `Document`
  Gets a RandomAccessContent object that can be used to read/write content "asynchronously".

  Parameters:
    `canWrite` - whether a request for a writeable RACI
    `shouldLock` - ignored
  Returns:
    a RandomAccessContentInterface instance
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### isReadByUser

    public boolean isReadByUser()
                         throws IfsException

  Description copied from class: `Document`
  Returns true if the current user has read the content to which this document refers. Note that this will return true for all documents refering to the same content.

  Returns:
    true if current user has read the content referred by this Document.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### isReadByOwner

    public boolean isReadByOwner()
                          throws IfsException

  Description copied from class: `Document`
  Returns true if the owner of the document has read the content via this document. This attribute is maintained per document.

  Returns:
    true if the owner has read the content refrerred by this document.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setReadByUser

    public void setReadByUser(boolean readState)
                       throws IfsException

  Description copied from class: `Document`
  Sets read indication (for the current user) for the content referred to by this Document. Note that this affects all documents referring to the same content. No exception is thrown when the user does not have read indication enabled.

  Parameters:
    `readState` - desired read indication for current user on this Document's content
  Throws:
    `IfsException` - if operation fails.
  (Published)

### generateFilename

    public java.lang.String generateFilename()
                                      throws IfsException

  Description copied from class: `Document`
  Generates a filename which is the objectname plus the format extension. This can be used as a default filename for operations such as getContent or checkOut. Note that this method does not prepend a path to the filename. Also note that this method will return null if this document has no content. Lastly, note that this method can produce long file names.

  Returns:
    a generated filename
  Throws:
    `IfsException` - if operation fails.
  (Published)

### generateThemes

    public void generateThemes(boolean fullThemes)
                        throws IfsException

  Description copied from class: `Document`
  Generates the Themes for this Document by submitting a request to Context to generate Themes.

  Each Theme may either be a single Theme word/phrase or a hierarchical list of parent Themes. If fullThemes is set to TRUE, every Theme will also have the full hierarchy of its parent Themes generated.

  Parameters:
    `fullThemes` - generates theme hierarchy information if TRUE
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getThemes

    public ContextTheme[] getThemes()
                             throws IfsException

  Description copied from class: `Document`
  Gets the Themes for a document, previously generated by a call to generateThemes().

  A document may have up to fifty Themes. Each Theme may either be a single Theme word/phrase or a string of parent Themes, separated by colons (':').

  There is a Weight associated with every Theme. A Weight is a numerical value that measures the importance of the Theme relative to other Themes for the document.

  Returns:
    an array of objects encapsulating a Context Theme and its associated Weight
  Throws:
    `IfsException` - if operation fails.
  (Published)

### generateSummary

    public void generateSummary(java.lang.String pointOfView,
                                long sizeAsPercent,
                                long sizeAsNumParagraphs,
                                java.lang.String summaryLevel)
                         throws IfsException

  Description copied from class: `Document`
  Generates one or more summaries for a document by submitting a request to Context to generate summaries.

  If GENERIC is passed for pointOfView, then Context will generate a single generic summary of the document, based on all the document Themes. If a specific Theme is passed for pointOfView, then Context will generate a summary based on that Theme. Only the Themes generated for the document by a previous call to generateThemes() may be used as input for pointOfView. If a null value is passed for pointOfView, then Context will generate a generic summary of the document, in addition to up to 50 other summaries, each based on one of Themes of the document. Only the Themes generated for the document by a previous call to generateThemes() may be used as input for pointOfView.

  Summaries are generated either by selecting specific sentences from the document, or by selecting specific paragraphs from the document. If summaryLevel is set to "S", then Context generates a sentence-level summary of the document. If summaryLevel is set to "P", then Context generates a paragraph-level summary of the document.

  The size of the summary generated for a document may be specified through the parameters sizeAsPercent and sizeAsNumParagraphs.

  The parameter sizeAsPercent specifies the maximum number of document paragraphs (or sentences) that will be included in the summary, as a percentage of the total number of paragraphs (or sentences) present in the document. The default is 10. To use the default value, pass 0 for sizeAsPercent.

  The parameter sizeAsNumParagraphs specifies the maximum number of document paragraphs (or sentences) that will be included in the summary. The default is 16. To use the default value, pass 0 for sizeAsNumParagraphs.

  When both sizeAsNumParagraphs and sizeAsPercent are specified, the parameter that yields a smaller summary size will be used.

  Parameters:
    `pointOfView` - the specific Theme(s) based on which the summary is generated
    `sizeAsPercent` - size of summary as a percentage of document size
    `sizeAsNumParagraphs` - size of summary specified as number of paragraphs or sentences
    `summaryLevel` - specifies whether summary is generated by selecting document paragraphs or sentences
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getSummary

    public java.io.Reader getSummary(java.lang.String pointOfView)
                              throws IfsException

  Description copied from class: `Document`
  Gets a specific summary of a document, previously generated by a call to generateSummary().

  Parameters:
    `pointOfView` - get the summary that is based on this particular point of view
  Returns:
    a Reader for fetching the summary
  Throws:
    `IfsException` - if operation fails.
  (Published)

### filterContent

    public void filterContent(boolean plaintext)
                       throws IfsException

  Description copied from class: `Document`
  Generates a HTML or plaintext version of the document, via the Context INSO filters. The format of the document to be filtered must be supported by the Context filters.

  Parameters:
    `plaintext` - when TRUE, indicates that a plaintext version of the document must be generated, otherwise an HTML version will be generated
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getFilteredContent

    public java.io.Reader getFilteredContent()
                                      throws IfsException

  Description copied from class: `Document`
  Gets the plaintext or HTML content of the document, previously generated by a call to filterContent()

  Returns:
    a Reader for fetching the plaintext or HTML content
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setContent

    public void setContent(DocumentDefinition def)
                    throws IfsException

  Description copied from class: `Document`
  Sets the content of this Document. This method is a cover on top of `LibraryObject.update`.

  Parameters:
    `def` - DocumentDefinition object describing desired updates.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### verifyContentObject

    protected ContentObject verifyContentObject()
                                         throws IfsException

  Description copied from class: `Document`
  Verifies the ContentObject of this Document is set.

  Returns:
    this Document's ContentObject
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### constructDocumentVector

    protected static java.util.Vector constructDocumentVector(LibrarySession sess,
                                                              java.util.Vector vector)
                                                       throws IfsException

  Description copied from class: `Document`
  Returns Document Vector from a Vector of S_DocumentData objects.

  Parameters:
    `sess` - current LibrarySession
    `vector` - vector of Document objects
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### constructDocument

    protected static Document constructDocument(LibrarySession sess,
                                                S_LibraryObjectData data)
                                         throws IfsException

  Description copied from class: `Document`
  Constructs a Document object from the S_LibraryObjectData object.

  Parameters:
    `sess` - current LibrarySession
    `data` - data component
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### vectorToDocumentArray

    protected static Document[] vectorToDocumentArray(java.util.Vector vector)

  Description copied from class: `Document`
  Converts a Vector of Document to an array of DirectoryGroup.

  Parameters:
    `vector` - Vector of Document objects
  Returns:
    array of Document objects that corresponds to Vector
  (Unpublished)

### vectorDocumentElement

    protected static Document vectorDocumentElement(java.util.Vector vector,
                                                    int index)

  Description copied from class: `Document`
  Returns a Document element from the Vector of Document objects at the specified index.

  Parameters:
    `vector` - Vector of Document objects
    `index` - index into Document
  Returns:
    the Document object
  (Unpublished)

### preCreate

    protected void preCreate(LibraryObjectDefinition lodef)
                      throws IfsException

  Description copied from class: `PublicObject`
  Extensibility point to perform actions prior to the creation of a PublicObject.

  Set an option that indicates that Categories are NOT to be created from within S_PublicObject.

  Overrides:
    `preCreate` in class `PublicObject`
  Parameters:
    `lodef` - object definition that will be used to create the object
  Throws:
    `IfsException` - if the operation fails

### postCreate

    protected void postCreate(LibraryObjectDefinition lodef)
                       throws IfsException

  Description copied from class: `PublicObject`
  Extensibility point to perform actions after the creation of a PublicObject.

  This assumes that a transaction context has already been established.

  Overrides:
    `postCreate` in class `PublicObject`
  Parameters:
    `lodef` - object definition that was used to create the object
  Throws:
    `IfsException` - if the operation fails

### preUpdate

    protected void preUpdate(LibraryObjectDefinition lodef)
                      throws IfsException

  Description copied from class: `PublicObject`
  Extensibility point to perform actions prior to the update of a PublicObject.

  Set an option that indicates that Categories are NOT to be created from within S_PublicObject.

  Overrides:
    `preUpdate` in class `PublicObject`
  Parameters:
    `lodef` - object definition used to define how the target object will be updated
  Throws:
    `IfsException` - if operation fails.

### preFree

    protected void preFree(LibraryObjectDefinition lodef)
                    throws IfsException

  Description copied from class: `PublicObject`
  Extensibility point to perform actions prior to the permanent deletion ("free") of a object.

  Override to free all existing categories, in such a way that the PO doesn't get updated for each category free.

  Overrides:
    `preFree` in class `PublicObject`
  Parameters:
    `lodef` - object definition used to hold options related to the free operation
  Throws:
    `IfsException` - if operation fails.

### isValidEventType

    protected boolean isValidEventType(AuditEvent event)
                                throws IfsException

  Description copied from class: `Document`
  Checks to see if the event type in the process of being posted on the target LibraryObject is consistent with the target.

  Overrides:
    `isValidEventType` in class `LibraryObject`
  Parameters:
    `event` - the event being posted on this object
  Returns:
    true if the type is consistent; false otherwise
  Throws:
    `IfsException` - if the operation fails

### auditLifecyclePolicySet

    protected void auditLifecyclePolicySet(LifecyclePolicy lp)
                                    throws IfsException

  Description copied from class: `Document`
  Audit the setting of a LifecyclePolicy on this document.

  Parameters:
    `lp` - the LifecyclePolicy set on this document
  Throws:
    `IfsException` - if the operation fails

### auditLifecycleStateUpdated

    public void auditLifecycleStateUpdated(LifecyclePolicyEntry lpe)
                                    throws IfsException

  Description copied from class: `Document`
  Audit the update of Lifecycle state on this document.

  Parameters:
    `lpe` - the LifecyclePolicyElement defining new state
  Throws:
    `IfsException` - if the operation fails

### auditLifecyclePolicyCleared

    protected void auditLifecyclePolicyCleared(LifecyclePolicy lp)
                                        throws IfsException

  Description copied from class: `Document`
  Audit the clearing of a LifecyclePolicy from this document.

  Parameters:
    `lp` - the LifecyclePolicy cleared from this document
  Throws:
    `IfsException` - if the operation fails

### auditRetentionPolicySet

    protected void auditRetentionPolicySet(RetentionPolicy rp)
                                    throws IfsException

  Description copied from class: `Document`
  Audit the setting of a RetentionPolicy on this document.

  Parameters:
    `rp` - the RetentionPolicy set on this document
  Throws:
    `IfsException` - if the operation fails

### auditRetentionPolicyCleared

    protected void auditRetentionPolicyCleared(RetentionPolicy rp)
                                        throws IfsException

  Description copied from class: `Document`
  Audit the clearing of a RetentionPolicy from this document.

  Parameters:
    `rp` - the RetentionPolicy cleared from this document
  Throws:
    `IfsException` - if the operation fails

### auditContentRead

    protected void auditContentRead(int mode)
                             throws IfsException

  Description copied from class: `Document`
  Audits content being read.

  Parameters:
    `mode` - the post mode
  Throws:
    `IfsException` - if the operation fails.

### auditUpdated

    protected void auditUpdated(LibraryObjectDefinition lodef)
                         throws IfsException

  Description copied from class: `Document`
  Creates audit events for the update operation.

  Overrides:
    `auditUpdated` in class `LibraryObject`
  Parameters:
    `lodef` - The update definition
  Throws:
    `IfsException` - if the operation fails.

### auditPublicObjectLocked

    protected void auditPublicObjectLocked(int lockType)
                                    throws IfsException

  Description copied from class: `Document`
  Audits a PublicObject being locked.

  Overrides:
    `auditPublicObjectLocked` in class `PublicObject`
  Parameters:
    `lockType` - the lock type
  Throws:
    `IfsException` - if the operation fails

### auditPublicObjectUnlocked

    protected void auditPublicObjectUnlocked(int lockType)
                                      throws IfsException

  Description copied from class: `Document`
  Audits a PublicObject being unlocked.

  Overrides:
    `auditPublicObjectUnlocked` in class `PublicObject`
  Parameters:
    `lockType` - the lock type
  Throws:
    `IfsException` - if the operation fails

### reportDocumentCreated

    protected void reportDocumentCreated()
                                  throws IfsException

  Description copied from class: `Document`
  Audits a Document create operation.

  Throws:
    `IfsException` - if the operation fails

### reportDocumentFreed

    protected void reportDocumentFreed()
                                throws IfsException

  Description copied from class: `Document`
  Audits a Document free operation.

  Throws:
    `IfsException` - if the operation fails

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD